EXTPROC CEnvi2
//***********************************************************
//*** KeyFlags.cmd - CEnvi2 for OS/2 tool show key states ***
//*** ver.1          and SHIFT keys when switching active ***
//***********************************************************

#define UPDATE_FREQUENCY   1000 // milliseconds between update

#include <KeyState.cmd>
#include <KeyPush.lib>

#define RSHIFT_DOWN   0x0001
#define LSHIFT_DOWN   0x0002
#define CTRL_DOWN     0x0004
#define ALT_DOWN      0x0008
#define SCROLL_ON     0x0010
#define NUMLOCK_ON    0x0020
#define CAPSLOCK_ON   0x0040
#define INSERT_ON     0x0080
#define LCTRL_DOWN    0x0100
#define LALT_DOWN     0x0200
#define RCTRL_DOWN    0x0400
#define RALT_DOWN     0x0800
#define SCROLL_DOWN   0x1000
#define NUMLOCK_DOWN  0x2000
#define CAPSLOCK_DOWN 0x4000
#define SYSREQ_DOWN   0x8000

#define VK_SHIFT      0x09
#define VK_CTRL       0x0A
#define VK_ALT        0x0B
#define VK_CAPSLOCK   0x0E
#define VK_INSERT     0x1A
#define VK_SCRLLOCK   0x1C
#define VK_NUMLOCK    0x1D
#define VK_SYSRQ      0x1F


while( True ) {
   suspend(UPDATE_FREQUENCY);
   printf("\n");

   Keys = GetLocalKeyboardStatus();
   KeyTable = GetKeyboardTable();

   printf("Local: ");
   if ( Keys & RSHIFT_DOWN )
      printf("RSHIFT_DOWN ");
   if ( Keys & LSHIFT_DOWN )
      printf("LSHIFT_DOWN ");
   if ( Keys & CTRL_DOWN )
      printf("CTRL_DOWN ");
   if ( Keys & LCTRL_DOWN )
      printf("LCTRL_DOWN ");
   if ( Keys & RCTRL_DOWN )
      printf("RCTRL_DOWN ");
   if ( Keys & ALT_DOWN )
      printf("ALT_DOWN ");
   if ( Keys & LALT_DOWN )
      printf("LALT_WODN ");
   if ( Keys & RALT_DOWN )
      printf("RALT_DONW ");
   if ( Keys & SCROLL_ON )
      printf("SCROLL_ON ");
   if ( Keys & SCROLL_DOWN )
      printf("SCROLL_DOWN ");
   if ( Keys & NUMLOCK_ON )
      printf("NUMLOCK_ON ");
   if ( Keys & NUMLOCK_DOWN )
      printf("NUMLOCK_DOWN ");
   if ( Keys & CAPSLOCK_ON )
      printf("CAPSLOCK_ON ");
   if ( Keys & CAPSLOCK_DOWN )
      printf("CAPSLOCK_DOWN ");
   if ( Keys & INSERT_ON )
      printf("INSERT_ON ");
   if ( Keys & SYSREQ_DOWN )
      printf("SYSREQ_DOWN ");

   printf("\n");

   printf("Table: ");
   if ( KeyTable[VK_SHIFT] & 0x80 )
      printf("SHIFT_DOWN ");
   if ( KeyTable[VK_CTRL] & 0x80 )
      printf("CTRL_DOWN ");
   if ( KeyTable[VK_ALT] & 0x80 )
      printf("ALT_DOWN ");
   if ( KeyTable[VK_SCRLLOCK] & 0x01 )
      printf("SCROLL_ON ");
   if ( KeyTable[VK_SCRLLOCK] & 0x80 )
      printf("SCROLL_DOWN ");
   if ( KeyTable[VK_NUMLOCK] & 0x01 )
      printf("NUMLOCK_ON ");
   if ( KeyTable[VK_NUMLOCK] & 0x80 )
      printf("NUMLOCK_DOWN ");
   if ( KeyTable[VK_CAPSLOCK] & 0x01 )
      printf("CAPSLOCK_ON ");
   if ( KeyTable[VK_CAPSLOCK] & 0x80 )
      printf("CAPSLOCK_DOWN ");
   if ( KeyTable[VK_INSERT] & 0x01 )
      printf("INSERT_ON ");
   if ( KeyTable[VK_SYSRQ] & 0x80 )
      printf("SYSREQ_DOWN ");

   printf("\n");
}

exit(EXIT_SUCCESS);

GetLocalKeyboardStatus()
{
   // Open $Kbd device
   rc = DosOpen("\\DEV\\KBD$",FileHandle,ActionTaken,0,0,
                OPEN_ACTION_OPEN_IF_EXISTS,
                OPEN_ACCESS_READONLY | OPEN_SHARE_DENYNONE,NULL);
   assert( 0 == rc );

   // call DosDevIOCTL to get kbd state
   #define KEYBOARD_CATEGORY     4
   #define KBD_GETSHIFTSTATE     0x0073
   #define GET_DATA_SIZE         3
   rc = DosDevIOCtl(FileHandle,KEYBOARD_CATEGORY,KBD_GETSHIFTSTATE,
                    NULL,0,0,Data,GET_DATA_SIZE,DataSize);
   assert( 0 == rc );
   ShiftState = BLObGet(Data,0,UWORD16);

   // close device
   DosClose(FileHandle);

   return ShiftState;
}



